define CORnoPV (nrep = !charend('/')/
                var1 = !charend('/') /
                var2 = !charend('/') /
                grp = !charend('/')  /
                wgt = !charend('/') /
                rwgt = !charend('/') /
                cons = !charend('/')/
                infile = !charend('/')).



get file !infile /keep !grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !var2 !var1.
select if (not missing(!var1) & not missing (!var2)).
sort cases by !grp.            
save outfile='c:\temp\sort.sav'.


*** COMPUTE ESTIMATE ***.

split file by !grp.            
                              
weight by !wgt.
descr !var1 !var2 / stat=mean stddev /save.
compute Y=!concat('Z',!var1)*!concat('Z',!var2).
split file off.
aggregate outfile=* /break=!grp /sumY=sum(Y) /n=n.
compute stat=sumY/n.

erase file='c:\temp\all.sav'.
save outfile='c:\temp\all.sav' /keep=!grp stat.


* REPLICATES.

!do !i=1 !to !nrep.
get file='c:\temp\sort.sav'.

split file by !grp.            
                              
weight by !concat(!rwgt,!i).
descr !var1 !var2/ stat=mean stddev /save.
compute Y=!concat('Z',!var1)*!concat('Z',!var2).
split file off.
aggregate outfile=* /break=!grp /sumY=sum(Y) /n=n.
compute statR=sumY/n.

erase file=!quote(!concat('C:\temp\',!var2,!i,'.sav')).
save outfile=!quote(!concat('C:\temp\',!var2,!i,'.sav')) /keep=!grp statR.
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('C:\temp\',!var2,'1.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('C:\temp\',!var2,!e,'.sav')).
!Doend.

sort cases by !grp.
match files file=* /table='c:\temp\all.sav' /by !grp.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

compute var=(statr-stat)**2.
exec.

save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!grp/ 
          stat= mean(stat)/
          var=sum(var).

compute var=!cons*var.




*** COMPUTE STANDARD ERROR ***.

compute SE=sqrt(var).
exec.

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp stat SE.

!enddefine.