define COR_2PV (nrep = !charend('/')/
               pv1 = !charend('/') /
               pv2 = !charend('/') /
               grp = !charend('/') /
               wgt = !charend('/') /
               rwgt = !charend('/') /
               cons = !charend('/')/
               infile = !charend('/')).



*** COMPUTE REGRESSION COEFFICIENTS ***.

get file !infile /keep=!grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !concat('pv1',!pv2) 
  !concat('pv2',!pv2) !concat('pv3',!pv2) !concat('pv4',!pv2) !concat('pv',5,!pv2) 
  !concat('pv1',!pv1) !concat('pv2',!pv1) !concat('pv3',!pv1) !concat('pv4',!pv1) !concat('pv',5,!pv1).
rename var (!concat('pv1',!pv1) 
  !concat('pv2',!pv1) !concat('pv3',!pv1) !concat('pv4',!pv1) !concat('pv',5,!pv1)=!concat('p1',!pv1) 
  !concat('p2',!pv1) !concat('p3',!pv1) !concat('p4',!pv1) !concat('p',5,!pv1)).
rename var (!concat('pv1',!pv2) 
  !concat('pv2',!pv2) !concat('pv3',!pv2) !concat('pv4',!pv2) !concat('pv',5,!pv2)=!concat('p1',!pv2) 
  !concat('p2',!pv2) !concat('p3',!pv2) !concat('p4',!pv2) !concat('p',5,!pv2)).
sort cases by !grp.            
save outfile='c:\temp\sort.sav'.

!do !j=1 !to 5.
get file='c:\temp\sort.sav'.

split file by !grp.            
                              
weight by !wgt.
split file layered by !grp.

!let !x=!concat('p',!j,!pv1).
!let !y=!concat('p',!j,!pv2).

descr !x !y /stat=mean stddev /save.
compute P=!concat('Z',!x)*!concat('Z',!y).
split file off.

aggregate outfile=* /break=!grp /sumP=sum(P) /n=n.
compute !concat('stat',!j)=sumP/n.

save outfile=!quote(!concat('c:\temp\temp',!J,'.sav')) /keep=!grp !concat('stat',!j).
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !GRP.
erase file='c:\temp\all.sav'.
save outfile='c:\temp\all.sav'.




* REPLICATES.

!do !i=1 !to !nrep.
!do !j=1 !to 5.

get file='c:\temp\sort.sav'.
split file layered by !grp.            
                              
weight by !CONCAT(!rwgt,!i).
split file by !grp.

!let !x=!concat('p',!j,!pv1).
!let !y=!concat('p',!j,!pv2).

descr !x !y /stat=mean stddev /save.
compute P=!concat('Z',!x)*!concat('Z',!y).
split file off.

aggregate outfile=* /break=!grp /sumP=sum(P) /n=n.
compute !concat('statR',!j)=sumP/n.

save outfile=!quote(!concat('c:\temp\temp',!J,'.sav')) /keep=!grp !concat('statR',!j).
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !GRP.

erase file=!quote(!concat('C:\temp\',!pv2,!i,'.sav')).
save outfile=!quote(!concat('C:\temp\',!pv2,!i,'.sav')).
!doend.




*** COMBINE RESULTS ***.

get file =!quote(!concat('C:\temp\',!pv2,'1','.sav')).
cache.

!Do !e = 2 !to !nrep.
add files/file=*/file=!quote(!concat('C:\temp\',!pv2,!e,'.sav')).
!Doend.

sort cases by !grp.
match files file=*/table= 'c:\temp\all.sav'/by !grp.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr1 to statr5/
	  b=stat1 to stat5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!grp/ 
          stat1 to stat5= mean(stat1 to stat5)/
          var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).




*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat1 to stat5).

do repeat a=stat1 to stat5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.

compute pvmerr=.25*(sum(pvar1 to pvar5)).




*** COMPUTE STANDARD ERROR [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp stat SE.

!enddefine.





