define dif_pv (nrep = !charend('/')/
                dep = !charend('/') /
                stat = !charend ('/') /
                within = !charend('/') /
                compare = !charend('/') /
                categ = !charend ('/') /
                wgt = !charend('/') /
                rwgt = !charend('/') /
                cons = !charend('/')/
                infile = !charend('/')).


*** COMPUTE ESTIMATE ***.

!do !j=1 !to 5.
get file !infile /keep !concat('pv1',!dep) 
  !concat('pv2',!dep) !concat('pv3',!dep) !concat('pv4',!dep) !concat('pv',5,!dep) 
  !within !compare !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) .
weight by !wgt.
aggregate outfile = * 
   /break=!within !compare /stat=!stat(!concat('pv',!j,!dep)).
exe.
casestovars /id=!within /index=!compare .

!let !n=!length(!categ).
!let !m=!LENGTH(!substr(!blanks(!n),2)).

!let !var=" ".
!do !a=1 !to !m.
!let !s=!LENGTH(!concat(!blanks(!a),' ')).
!do !b=!s !to !n.

!let !d=!substr(!categ,!a,1).
!let !e=!substr(!categ,!b,1).
compute !concat('stat',!d,'_',!e)=
        !concat('stat.',!d)-!concat('stat.',!e).
!let !var=!concat(!var,'stat',!d,'_',!e,' ').
!doend.
!doend.

VARSTOCASES  /MAKE !concat('stat',!j) FROM !var
 /INDEX = contrast(!concat('stat',!j)) /KEEP = !within /NULL = DROP.
save outfile=!quote(!concat('c:\temp\temp',!J,'.sav')).
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !within contrast.
sort cases by !within CONTRAST.
save outile='c:\temp\all.sav'.



* REPLICATES.

!do !i= 1 !to !nrep.
!do !j=1 !to 5.
get file !infile /keep !concat('pv1',!dep) 
  !concat('pv2',!dep) !concat('pv3',!dep) !concat('pv4',!dep) !concat('pv',5,!dep) 
  !within !compare !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) .
weight by !concat(!rwgt,!i).
aggregate outfile = * 
   /break=!within !compare /stat=!stat(!concat('pv',!j,!dep)).
exe.
casestovars /id=!within /index=!compare .

!let !n=!length(!categ).
!let !m=!LENGTH(!substr(!blanks(!n),2)).

!let !var=" ".
!do !a=1 !to !m.
!let !s=!LENGTH(!concat(!blanks(!a),' ')).
!do !b=!s !to !n.

!let !d=!substr(!categ,!a,1).
!let !e=!substr(!categ,!b,1).
compute !concat('stat',!d,'_',!e)=
        !concat('stat.',!d)-!concat('stat.',!e).
!let !var=!concat(!var,'stat',!d,'_',!e,' ').
!doend.
!doend.

VARSTOCASES  /MAKE !concat('statR',!j) FROM !var
 /INDEX = contrast(!concat('statR',!j)) /KEEP = !within /NULL = DROP.
save outfile=!quote(!concat('c:\temp\temp',!J,'.sav')).
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !within contrast.

save outfile=!quote(!concat('C:\temp\',!dep,!i,'.sav')).
!doend.



*** COMBINE RESULTS ***.

get file =!quote(!concat('c:\temp\',!dep,'1','.sav')).

!Do !e = 2 !to !nrep.
add files file=* /file=!quote(!concat('c:\temp\',!dep,!e,'.sav')).
!Doend.

sort cases by !within CONTRAST.
match files file=* /table='c:\temp\all.sav' /by !within CONTRAST.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr1 to statr5/
	  b=stat1 to stat5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!within contrast/ 
          stat1 to stat5= mean(stat1 to stat5)/
          var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).




*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat1 to stat5).

do repeat a=stat1 to stat5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.

compute pvmerr=.25*(sum(pvar1 to pvar5)).




*** COMPUTE STANDARD ERROR [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).

formats stat (f8.3)/ SE (f10.6).

string contr (a3).
compute contr=substr(contrast,5,3).
list cases/var= !within contr stat SE.
save outfile='c:\temp\temp.sav' .
get file='c:\temp\temp.sav'/keep=!within contr stat se.
casestovars /id=!within /index=contr /groupby=index.

!enddefine.