define REG_PV (nrep = !charend('/')/
                ind = !charend('/') /
                dep = !charend('/') /
                grp = !charend('/')  /
                wgt   = !charend('/') /
                rwgt   = !charend('/') /
                cons = !charend('/')/
                infile = !charend('/')).

get file !infile /keep=!grp !wgt !concat(!rwgt,1) to !concat(!rwgt,!nrep) !IND !concat('pv1',!dep) 
  !concat('pv2',!dep) !concat('pv3',!dep) !concat('pv4',!dep) !concat('pv',5,!dep) .
sort cases by !grp.
erase file 'c:\temp\sort.sav'.
save outfile='c:\temp\sort.sav'.

*** COMPUTE REGRESSION COEFFICIENTS ***.

!do !j=1 !to 5.

get file 'c:\temp\sort.sav'.

split file by !grp.            
                              
weight by !wgt.

REGRESSION
  /DEPENDENT !concat('pv',!j,!dep)
  /METHOD=ENTER !ind
  /OUTFILE=COVB(!quote(!concat('C:\temp\coef',!j,'.sav'))) .
get file=!quote(!concat('C:\temp\coef',!j,'.sav')).

select if (rowtype_='EST').
rename var(CONST_=b0).
VARSTOCASES  /MAKE !concat('stat',!j) FROM b0 !ind
 /INDEX = ind(!concat('stat',!j)) /KEEP =  !grp /NULL = KEEP.
sort cases by !grp IND.
save outfile=!quote(!concat('c:\temp\temp',!J,'.sav')).
!doend.




match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !GRP ind.
erase file='c:\temp\all.sav'.
save outfile='c:\temp\all.sav'.




* REPLICATES.

!do !i=1 !to !nrep.
!do !j=1 !to 5.

get file 'c:\temp\sort.sav'.

split file by !grp.            
                              
weight by !CONCAT(!rwgt,!i).

REGRESSION
  /DEPENDENT !concat('pv',!j,!dep)
  /METHOD=ENTER !ind
  /OUTFILE=COVB(!quote(!concat('C:\temp\coef',!j,'.sav'))) .
get file=!quote(!concat('C:\temp\coef',!j,'.sav')).
select if (rowtype_='EST').
rename var(CONST_=b0).
VARSTOCASES  /MAKE !concat('statR',!j) FROM b0 !ind
 /INDEX = ind(!concat('statR',!j)) /KEEP =  !grp /NULL = KEEP.
sort cases by !grp IND.
save outfile=!quote(!concat('c:\temp\temp',!J,'.sav')).
!doend.

match files file='c:\temp\temp1.sav'
           /file='c:\temp\temp2.sav'
           /file='c:\temp\temp3.sav'
           /file='c:\temp\temp4.sav'
           /file='c:\temp\temp5.sav'
           /by !GRP ind.

erase file=!quote(!concat('C:\temp\',!dep,!i,'.sav')).
save outfile=!quote(!concat('C:\temp\',!dep,!i,'.sav')).
!doend.




*** COMBINE RESULTS ***.

get file =!quote(!concat('C:\temp\',!dep,'1','.sav')).
cache.

!Do !e = 2 !to !nrep.
add files/file=*/file=!quote(!concat('C:\temp\',!dep,!e,'.sav')).
!Doend.

SORT CASES BY !grp IND.
match files file=*/table= 'c:\temp\all.sav'/by !grp IND.
exec.



*** COMPUTE SAMPLING VARIANCE (U) ***.

do repeat a=statr1 to statr5/
	  b=stat1 to stat5/
	  c=var1 to var5.
compute c=(a-b)**2.
end repeat.
save outfile = 'c:\temp\regmod.sav'.

aggregate outfile=*/
	  break=!grp IND/ 
          stat1 to stat5= mean(stat1 to stat5)/
          var1 to var5 = sum(var1 to var5).

do repeat a=var1 to var5.
compute a=!cons*a.
end repeat.

compute pv_var=mean(var1 to var5).




*** CALCULATING MEASUREMENT VARIANCE (Bm) ***.

compute stat=mean(stat1 to stat5).

do repeat a=stat1 to stat5/b=pvar1 to pvar5.
compute b=(a-stat)**2.
end repeat.

compute pvmerr=.25*(sum(pvar1 to pvar5)).




*** COMPUTE STANDARD ERROR [V = U + (1+1/M)Bm] ***.

compute SE=sqrt(pv_var+1.2*pvmerr).

formats stat (f8.3)/ SE (f10.6).
list cases/var= !grp IND stat SE.

!enddefine.





